#include <assert.h>
#include <stdlib.h>
#include "xametadataadaptctxmmf.h"
#include "xaobjectitf.h"
#include "cmetadatautilityitf.h"

XAAdaptationBaseCtx* XAMetadataAdaptCtxMMF_Create(XADataSource * pDataSrc)
{

    XAMetadataAdaptationMMFCtx *pSelf = NULL;
    DEBUG_API("->XAMetadataAdaptCtxMMF_Create");
    
    pSelf = calloc(1, sizeof(XAMetadataAdaptationMMFCtx));
    if ( pSelf)
    {
          
        if( XAAdaptationBaseMMF_Init(&(pSelf->baseObj),XAMDAdaptation)
            != XA_RESULT_SUCCESS )
        {
            DEBUG_ERR("Failed to init base context!!!");
            free(pSelf);
            pSelf = NULL;
        }
        else
            
        {
            pSelf->baseObj.baseObj.fwtype = FWMgrFWMMF;
            pSelf->xaSource = pDataSrc;
        }

		if(pDataSrc)
		{
			pSelf->mmfContext = mmf_metadata_utility_init((char *)(( (XADataLocator_URI*)(pDataSrc->pLocator))->URI));
			if(!pSelf->mmfContext)
            {
	            DEBUG_ERR("Failed to init mmf context!!!");
    	        free(pSelf);
        	    pSelf = NULL;           
            }
		}

    }

    DEBUG_API("<- XAMetadataAdaptCtxMMF_Create");
    return (XAAdaptationBaseCtx*)(&pSelf->baseObj.baseObj);
}


/*
 * XAresult XAMediaPlayerAdaptMMF_PostInit()
 * 2nd phase initialization of Media Player Adaptation Context
 * @param XAMediaPlayerAdaptationMMFCtx* ctx - pointer to Media Player adaptation context
 * @return XAresult - Success value
 */
XAresult XAMetadataAdaptCtxMMF_PostInit( XAAdaptationMMFCtx* bCtx )
{
 	XAresult ret = XA_RESULT_SUCCESS;
 
  DEBUG_API("<-XAMetadataAdaptCtxMMF_PostInit");
  return ret;
}

/*
 * void XAMediaPlayerAdaptMMF_Destroy( XAMediaPlayerAdaptationMMFCtx* ctx )
 * Destroys Media Player Adaptation Context
 * @param ctx - Media Player Adaptation context to be destroyed
 */
void XAMetadataAdaptCtxMMF_Destroy( XAAdaptationMMFCtx* bCtx )
{
    DEBUG_API("->XAMetadataAdaptCtxMMF_Destroy");
    if(bCtx == NULL)
    {
        DEBUG_ERR("Invalid parameter!!");
        DEBUG_API("<-XAMetadataAdaptCtxMMF_Destroy");
        return;
    }
	
    if(((XAMetadataAdaptationMMFCtx*)bCtx)->mmfContext)
    {
        mmf_metadata_utility_destroy(((XAMetadataAdaptationMMFCtx*)bCtx)->mmfContext);
    }

    XAAdaptationBase_Free( &bCtx->baseObj );
    free(bCtx);
    bCtx = NULL;

    DEBUG_API("<-XAMetadataExtractorAdaptMMF_Destroy");
}


